@use "sass:map";
@use "tokens" as tokens;


/* # Generate App Tokens #

     Hier werden alle App Tokens als CSS Variablen global im :root definiert. 
     Dadurch können sie in allen Webcomponents genutzt werden, auch wenn shadow-root aktiv ist.
     Auf die hier generierten Vars kann man direkt oder mittels der von Adamantium bereitgestellten
     Funktionen zugreifen. 

     Falls mehrere Modes existieren, weren diese ebenfalls generiert. Zugriff wird dann via data-mode="modename" auf dem html Tag 
     ermöglicht.
*/

:root {
	
	// generate token css vars
	@each $mode, $token-categories in tokens.$app-tokens {
        // when default mode...
        @if type-of($token-categories) == map and $mode == "default" {
            // get all categories
            @each $token-categorie, $tokens in $token-categories {
                // get all tokens and values
                @each $token, $token-value in $tokens {
                    // check if token is composit token, if yes, write a var for every subtoken
                    @if type-of($token-value) == map {
                        @each $composit-token, $composit-token-value in $token-value {
                            --#{tokens.$token-identifier}#{$token-categorie}-#{$token}-#{$composit-token}: #{$composit-token-value};
                        }
                    // if not, write the simple topen
                    } @else {
                        --#{tokens.$token-identifier}#{$token-categorie}-#{$token}: #{$token-value};
                    }
                }
            }

        // for every custom  mode
		} @else if type-of($token-categories) == map {

            &[data-mode="#{$mode}"] {
                // get all categories
                @each $token-categorie, $tokens in $token-categories {
                    // get all tokens and values
                    @each $token, $token-value in $tokens {
                        // check if token is composit token, if yes, write a var for every subtoken
                        @if type-of($token-value) == map {
                            @each $composit-token, $composit-token-value in $token-value {
                                --#{tokens.$token-identifier}#{$token-categorie}-#{$token}-#{$composit-token}: #{$composit-token-value};
                            }
                        // if not, write the simple topen
                        } @else {
                            --#{tokens.$token-identifier}#{$token-categorie}-#{$token}: #{$token-value};
                        }
                    }
                }
			}
        }
	}
}

